# coding: utf-8

"""
    HiddenLayer ModelScan V2

    HiddenLayer ModelScan API for scanning of models

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from hiddenlayer.sdk.rest.models.security_posture import SecurityPosture
from typing import Optional, Set
from typing_extensions import Self

class SensorSORModelCardResponse(BaseModel):
    """
    SensorSORModelCardResponse
    """ # noqa: E501
    model_id: StrictStr
    created_at: StrictInt = Field(description="Unix Nano Epoch")
    plaintext_name: StrictStr
    active_versions: List[StrictInt]
    source: StrictStr
    tags: Optional[Dict[str, Any]] = None
    model_scan_threat_level: Optional[StrictStr] = None
    attack_monitoring_threat_level: Optional[StrictStr] = None
    security_posture: Optional[SecurityPosture] = None
    __properties: ClassVar[List[str]] = ["model_id", "created_at", "plaintext_name", "active_versions", "source", "tags", "model_scan_threat_level", "attack_monitoring_threat_level", "security_posture"]

    @field_validator('model_scan_threat_level')
    def model_scan_threat_level_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['safe', 'unsafe', 'suspicious', 'not available']):
            raise ValueError("must be one of enum values ('safe', 'unsafe', 'suspicious', 'not available')")
        return value

    @field_validator('attack_monitoring_threat_level')
    def attack_monitoring_threat_level_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['safe', 'unsafe', 'suspicious', 'not available']):
            raise ValueError("must be one of enum values ('safe', 'unsafe', 'suspicious', 'not available')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SensorSORModelCardResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of security_posture
        if self.security_posture:
            _dict['security_posture'] = self.security_posture.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SensorSORModelCardResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "model_id": obj.get("model_id"),
            "created_at": obj.get("created_at"),
            "plaintext_name": obj.get("plaintext_name"),
            "active_versions": obj.get("active_versions"),
            "source": obj.get("source"),
            "tags": obj.get("tags"),
            "model_scan_threat_level": obj.get("model_scan_threat_level"),
            "attack_monitoring_threat_level": obj.get("attack_monitoring_threat_level"),
            "security_posture": SecurityPosture.from_dict(obj["security_posture"]) if obj.get("security_posture") is not None else None
        })
        return _obj


